"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;
require("core-js/modules/es.regexp.to-string.js");
var _react = _interopRequireDefault(require("react"));
function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }
/* eslint-disable react/prop-types */

class ErrorBoundary extends _react.default.Component {
  // Constructor for initializing Variables etc in a state
  // Just similar to initial line of useState if you are familiar
  // with Functional Components
  constructor(props) {
    super(props);
    this.state = {
      error: null,
      errorInfo: null
    };
  }

  // This method is called if any error is encountered
  componentDidCatch(error, errorInfo) {
    // Catch errors in any components below and
    // re-render with error message
    this.setState({
      error: error,
      errorInfo: errorInfo
    });

    // You can also log error messages to an error
    // reporting service here
  }

  // This will render this component wherever called
  render() {
    var _this$props;
    if (this.state.errorInfo) {
      // Error path
      return /*#__PURE__*/_react.default.createElement("div", null, /*#__PURE__*/_react.default.createElement("h2", null, "An Error Has Occurred"), /*#__PURE__*/_react.default.createElement("details", null, this.state.error && this.state.error.toString(), /*#__PURE__*/_react.default.createElement("br", null), this.state.errorInfo.componentStack));
    }
    // Normally, just render children, i.e. in
    // case no error is Found
    return (_this$props = this.props) === null || _this$props === void 0 ? void 0 : _this$props.children;
  }
}
var _default = ErrorBoundary;
exports.default = _default;